'*******************************************************************************
'*    Description : SHT21_POD                                                  *
'*    Revision    : 2.0                                                        *
'*    Controller  : ATMEGA8                                                    *
'*******************************************************************************
'                                                                              '
'* Fuse bits * LF: 0xE4 HF: 0xD9                 8  .              '
'* Fuse bits * LF: 0xFD HF: 0xD9                 4,9152  .          '
'***************************_*******************************'
$regfile = "m8def.dat"                                      ' POD 8
'$crystal = 8000000                                          ' 8 
$crystal = 4915200                                          ' 4,9152 
$baud = 19200
$lib "mcsbyte.lbx"
$lib "ds1307clock.lib"                                      '  ds1307

$hwstack = 150
$swstack = 150
$framesize = 300
$eeprom
'$sim                                                        '

'*********** *******************
Config Lcd = 16 * 2                                         '  16*2 (   HD44780)
'Config Lcdpin = Pin , Db4 = Portb.4 , Db5 = Portb.5 , Db6 = Portb.6 , Db7 = Portb.7 , E = Portb.2 , Rs = Portb.3
Config Lcdpin = Pin , Rs = Portb.0 , E = Portb.1 , Db4 = Portb.2 , Db5 = Portb.3 , Db6 = Portb.4 , Db7 = Portb.5       ' LCD
Config Scl = Portc.5                                        'Configure i2c SCL
Config Sda = Portc.4                                        'Configure i2c SDA
Const Ds1307w = &HD0                                        '    ds1307 
Const Ds1307r = &HD1                                        '    ds1307 
Config Portc.0 = Output                                     '    Q1
Config Portc.2 = Output                                     '    Q2

'  RS232 (RS485)
Config Com1 = Dummy , Synchrone = 0 , Parity = None , Stopbits = 1 , Databits = 8 , Clockpol = 0
Config Print = Portd.2 , Mode = Set                         ' 
Config Portd.2 = Output                                     '   RS485  
Config Serialin = Buffered , Size = 8                       ' RS485   
Cursor Off                                                  ' 
Cls                                                         ' 

'***       .  (Q1,Q2, )

Set Portd.7 : Ok Alias Pind.7
Set Portd.6 : Esc Alias Pind.6
Set Portd.4 : Up Alias Pind.4
Set Portd.5 : Down Alias Pind.5
Set Portd.3 : Fen Alias Pind.3
Q1 Alias Portc.0                                            '  Q1
Q2 Alias Portc.2                                            '  Q2

Q1 = 0
Q2 = 0

'**********  SHT-21 *****************************
Dim Data1 As Byte
Dim Data2 As Byte
Dim Crc As Byte
Dim Datat As Word
Dim Datah As Word
Dim T As Single
Dim H As Single
Dim 6t1 As Byte
Dim 6t2 As Byte
Dim 6h1 As Byte
Dim 6h2 As Byte
Dim 0t1 As Byte , 0t2 As Byte , 0t3 As Byte , 0t4 As Byte
Dim 0h1 As Byte , 0h2 As Byte , 0h3 As Byte , 0h4 As Byte
Dim Ttt As String * 5 , 00h As String * 5 , 06t As String * 5 , 06h As String * 5
Dim T0 As Single
Dim H0 As Single
Dim T00 As Single
Dim H00 As Single
Dim T06 As Single
Dim H06 As Single
'***
Dim X1 As Byte
Dim Aa As Byte
Dim J1 As Byte
Dim M1 As Byte
Dim D1 As Byte
Dim H1 As Byte
Dim Min1 As Byte

'***************** Integer  ****************************************
Dim A As Integer                                            '   A
Dim B As Integer                                            '   B
Dim Tem1 As Single                                          '   Tem1
Dim Tem2 As Single                                          '   Tem2
Dim C As Integer                                            '   C
Dim D As Integer                                            '   D
Dim Vla1 As Single                                          '   Vla1
Dim Vla2 As Single                                          '   Vla2


'*****************  Eeprom     ********************************
Dim Ae As Eram Integer                                      '    EEPROM Ae
Dim Be As Eram Integer                                      '    EEPROM Be
Dim Ce As Eram Integer                                      '    EEPROM Ce
Dim De As Eram Integer                                      '    EEPROM De
A = Ae
B = Be
C = Ce
D = De

'*****************  Eeprom 24C64  ************************************
Dim Hour_last As Byte
Dim Rec As Bit
Dim Block As Byte
Dim Page As Byte
Dim 6rec As Bit

Dim Block_eeprom As Eram Byte
Dim Page_eeprom As Eram Byte
Dim Block_number_eeprom As Eram Byte


     Block = Block_eeprom
       If Block = 255 Then
         Block = &HA0
         Block_eeprom = Block
       End If


     Page = Page_eeprom
        If Page = 255 Then
          Page = 0
        End If

Dim Block_number As Byte

 Block_number = Block_number_eeprom

   If Block_number = 255 Then
     Block_number = 0
    End If




'*******      
Dim A1 As Byte
Dim A2 As Byte
Dim A3 As Byte
Dim A4 As Byte
Dim A5 As Byte
Dim A6 As Byte
Dim A7 As Byte
Dim A8 As Byte
Dim A9 As Byte
Dim A10 As Byte
Dim A11 As Byte
Dim A12 As Byte
Dim A13 As Byte
Dim A14 As Byte
Dim A15 As Byte
Dim A16 As Byte

Dim Zoomzoom As Byte



Dim S1 As Single
Dim S2 As Single
Dim W(4) As Byte
Dim I As Byte
Dim Adress As Word



Dim Seco As Byte
Dim Mine As Byte
Dim Hour As Byte
Dim Day As Byte
Dim Dat As Byte
Dim Month As Byte
Dim Year As Byte

Const 6hour = 6                                             '6 

'********  RS232 (RS485) *********************************************
Dim Mrs(8) As Byte
Dim Kol As Byte
Dim Drs(8) As Byte
Dim No As Byte


Dim Irs As Byte , Jrs As Word
Dim Ars As Byte                                             ' Case2
Dim Brs As Byte                                             ' Case2


'***  RS485
Dim Rs As String * 5
Enable Interrupts
'Enable Urxc

'   
Const Num = 21                                              '    SHT21
Const Zapros = 255                                          '     


'**********************************************************************
Declare Sub Sht21th                                         '  
Declare Sub __()                             '  __()
Declare Sub __()                               '  __()
Declare Sub                                              '  
Declare Sub ()                                        '  ()
Declare Sub Rs_485                                          '    RS485
Declare Sub                                       '  
Declare Sub _                                 '   

'***
Deflcdchar 0 , 8 , 20 , 8 , 3 , 4 , 4 , 4 , 3               ' 
Deflcdchar 1 , 32 , 4 , 4 , 14 , 14 , 31 , 31 , 14          '  
Deflcdchar 2 , 4 , 10 , 17 , 31 , 17 , 17 , 17 , 31         '  
Deflcdchar 3 , 32 , 4 , 4 , 14 , 14 , 31 , 31 , 32          '  
Deflcdchar 4 , 32 , 31 , 31 , 14 , 14 , 4 , 4 , 32          '  
Deflcdchar 5 , 31 , 23 , 16 , 21 , 1 , 29 , 31 , 31         '  
Deflcdchar 6 , 18 , 27 , 9 , 27 , 18 , 9 , 32 , 31          '  
Deflcdchar 7 , 32 , 32 , 32 , 32 , 32 , 32 , 32 , 32        ' 

' - SHT21  H80 , H81 
'   SHT21  7:

'0xE3 -  .       SCL    .
'0xE5 -  .  SCL -      .
'0xF3 -  .        SCL   .
'0xF5 -  .  SCL  .
'0xE6 -     .
'0xE7 -     .
'0xFE -  .

'********  *********
:
Cls
Lcd "*** SHT-21 *** "

Do

Gosub Clock                                                 ' 
  Gosub Sht21th                                             '   
'Waitms 900                                                  '
      Gosub Eeprom_24c16                                    '   24c16
        Gosub Rs_485                                        ' RS485    
Progg:
Call                                                  ' () ""
Call                                                     ' () ""

Cls                                                         '    
 Lcd Chr(2) ; Fusing(t , "#.#") ; Chr(0) ; " " ; Chr(1) ; Fusing(h , "#.#") ; "%"
  Locate 2 , 1
    Lcd " " ; Hour ; ":" ; Mine ; " " ; Dat ; "/" ; Month ; "/" ; Day
      If Esc = 0 Then Goto Meni                             ' 
       If Fen = 0 Then Goto 24cxx

    Waitms 500

 Loop
      End

'*** SHT-21T  ***
Sub Sht21th:

I2cstart
I2cwbyte &H80                                               ' - SHT21
I2cwbyte &HE3                                               '     
 Waitms 100                                                 '

I2cstart
I2cwbyte &H81                                               '  
I2crbyte Data1 , Ack                                        '  ,   
I2crbyte Data2 , Ack                                        '  
I2crbyte Crc , Nack                                         '    (   )
I2cstop                                                     ' 

'******
Datat = Data1
Shift Datat , Left , 8
Datat = Datat + Data2
T = Datat * 175.72
T = T / 65536
T = T - 46.85

'******

'*** SHT-21H  ***
'Sht21h:

I2cstart
I2cwbyte &H80                                               ' - SHT21
I2cwbyte &HE5                                               '     
 Waitms 100                                                 '

I2cstart
I2cwbyte &H81                                               '  
I2crbyte Data1 , Ack                                        '  ,   
I2crbyte Data2 , Ack                                        '  
I2crbyte Crc , Nack                                         '    (   )
I2cstop                                                     ' 

'******
Datah = Data1
Shift Datah , Left , 8                                      '  8 
Datah = Datah + Data2
H = Datah * 125
H = H / 65536
H = H - 6

'******
End Sub
'***   

Clock:                                                      '   RTC ds1307   

Hour_last = Hour                                            '       (       EEPROM)

I2cstart
I2cwbyte Ds1307w
I2cwbyte &H00
I2cstart
I2cwbyte Ds1307r
I2crbyte Seco , Ack
I2crbyte Mine , Ack
I2crbyte Hour , Ack
I2crbyte Day , Ack
I2crbyte Dat , Ack
I2crbyte Month , Ack
I2crbyte Year , Nack
I2cstop
 Seco = Makedec(seco) : Mine = Makedec(mine) : Hour = Makedec(hour)
 Day = Makedec(day) : Dat = Makedec(dat) : Month = Makedec(month) : Year = Makedec(year)


Return


'*** 
Meni:
Cls
Rem . 
Lcd "c. pee " ; Chr(3)
Locate 2 , 1
Rem . 
Lcd "c. aa " ; Chr(4)

Do
If Up = 0 Then Goto Ust_v
If Down = 0 Then Goto Ust_d
If Ok = 0 Then Goto 

    Loop
'***

Ust_v:

'*******************************************************************************

   '     () ds1307, 

   Cls
   Aa = 0
   X1 = Year
   Do
   If X1 > 99 Then X1 = 9
   If X1 < 9 Then X1 = 99
   Locate 1 , 1
   Lcd "[>aa<]"
   Locate 2 , 1
   Lcd "o: " ; X1 ; "  "
   __
   J1 = X1
   Loop Until Aa = 1

'*******************************************************************************

   '     () ds1307, 

   Cls
   Aa = 0
   X1 = Month
   Do
   If X1 > 12 Then X1 = 1
   If X1 < 1 Then X1 = 12
   Locate 1 , 1
   Lcd "[>aa<]"
   Locate 2 , 1
   Lcd "Mec: " ; X1 ; "  "
   __
   M1 = X1
   Loop Until Aa = 1

'*******************************************************************************

   '     () ds1307, 

   Cls
   Aa = 0
   X1 = Day
   Do
   If X1 > 31 Then X1 = 1
   If X1 < 1 Then X1 = 31
   Locate 1 , 1
   Lcd "[>aa<]"
   Locate 2 , 1
   Lcd "e: " ; X1 ; "  "
   __
   D1 = X1
   Loop Until Aa = 1
   Year = J1
   Month = M1
   Day = D1
   Gosub _

'*******************************************************************************

   '     () ds1307, 

   Cls
   Aa = 0
   X1 = Hour
   Do
   If X1 > 23 Then X1 = 0
   If X1 < 0 Then X1 = 23
  Locate 1 , 1
   Lcd "[>Bpe<]"
   Locate 2 , 1
   Lcd "ac: " ; X1 ; "  "
   __
   H1 = X1
   Loop Until Aa = 1

'*******************************************************************************

   '     () ds1307, 

   Cls
   Aa = 0
   X1 = Mine
   Do
   If X1 > 59 Then X1 = 0
   If X1 < 1 Then X1 = 59
   Locate 1 , 1
   Lcd "[>Bpe<]"
   Locate 2 , 1
   Lcd "My: " ; X1 ; " "
   __
   Min1 = X1
   Loop Until Aa = 1

   Hour = H1
   Mine = Min1
   Seco = 0
   Gosub _

         Goto 
'***
_:
  Day = Makebcd(day) : Month = Makebcd(month) : Year = Makebcd(year)
  I2cstart                                                  ' Generate start code
  I2cwbyte Ds1307w                                          ' send address
  I2cwbyte 4                                                ' starting address in 1307
  I2cwbyte Day                                              ' Send Day
  I2cwbyte Month                                            ' Mon
  I2cwbyte Year                                             ' 
  I2cstop
Return

_:
  Seco = Makebcd(seco) : Mine = Makebcd(mine) : Hour = Makebcd(hour)
  I2cstart                                                  ' Generate start code
  I2cwbyte Ds1307w                                          ' send address
  I2cwbyte 0                                                ' starting address in 1307
  I2cwbyte Seco                                             ' Send Data to SECONDS
  I2cwbyte Mine                                             ' MINUTES
  I2cwbyte Hour                                             ' Hours
  I2cstop
Return

'*******************************************************************************

Ust_d:

'***
'    eeprom ,  Q2

   Cls
   Aa = 0
   X1 = A
   Do
   If X1 > 10 Then X1 = 7
   If X1 < 7 Then X1 = 10
   Locate 1 , 1
   Lcd "[>Bòop e.<]"
   Locate 2 , 1
   Lcd "Te. .: " ; X1 ; "  "
   __
   Tem1 = X1
   Loop Until Aa = 1
    A = Tem1

'*******************************************************************************
'    eeprom ,  Q2

   Cls
   Aa = 0
   X1 = B
   Do
   If X1 > 10 Then X1 = 4
   If X1 < 4 Then X1 = 10
   Locate 1 , 1
   Lcd "[>Bòop e.<]"
   Locate 2 , 1
   Lcd "Te. ú.: " ; X1 ; "  "
   __
   Tem2 = X1
   Loop Until Aa = 1
    B = Tem2

'***
'    eeprom ,  Q1

   Cls
   Aa = 0
   X1 = C
   Do
   If X1 > 80 Then X1 = 50
   If X1 < 50 Then X1 = 80
   Locate 1 , 1
   Lcd "[ c.aoc]"
   Locate 2 , 1
   Lcd "Ba. .: " ; X1 ; "  "
   __
   Vla1 = X1
   Loop Until Aa = 1
    C = Vla1

'*******************************************************************************
'    eeprom ,  Q1

   Cls
   Aa = 0
   X1 = D
   Do
   If X1 > 80 Then X1 = 49
   If X1 < 49 Then X1 = 80
   Locate 1 , 1
   Lcd "[ c.aoc]"
   Locate 2 , 1
   Lcd "Ba. ú.: " ; X1 ; "  "
   __
   Vla2 = X1
   Loop Until Aa = 1
    D = Vla2
   Gosub _

'***

_:
 Writeeeprom A , Ae                                         '   A    
 Writeeeprom B , Be                                         '   B    
 Writeeeprom C , Ce                                         '   C    
 Writeeeprom D , De                                         '   D    

    Return

'***

'*******************************************************************************
'    ,    

Sub __()
   Waitms 300
   If Up = 0 Then Incr X1
   If Down = 0 Then Decr X1
   If Ok = 0 Then : Aa = 1 : Else : : Aa = 0 : End If
End Sub

'***

'*******************************************************************************
'   .  .     , 

Sub 

  Tem1 = A
  Tem2 = B

  If T => Tem2 Then : Q2 = 0 : Locate 2 , 16 : Lcd Chr(7) : End If

  If T <= Tem1 Then : Q2 = 1 : Locate 2 , 16 : Lcd Chr(6) : End If

  Waitms 500                                                '     

End Sub
'*******************************************************************************
'   .  .     , 

Sub 

  Vla1 = C
  Vla2 = D

  If H => Vla1 Then : Q1 = 1 : Locate 2 , 15 : Lcd Chr(5) : End If

  If H <= Vla2 Then : Q1 = 0 : Locate 2 , 15 : Lcd Chr(7) : End If

  Waitms 500                                                '     

End Sub
'*******************************************************************************
'  24C64  

Eeprom_24c16:

  If Hour = 6hour Then
    If 6rec = 0 Then S1 = T : Call  : 6t1 = W(1) : 6t2 = W(2) : S1 = H : Call  : 6h1 = W(1) : 6h2 = W(2) : 6rec = 1       '     .    6 
      Else
       6rec = 0
End If
  S1 = T : Call  : 0t1 = W(1) : 0t2 = W(2) : 0t3 = W(3) : 0t4 = W(4) : S1 = H : Call  : 0h1 = W(1) : 0h2 = W(2) : 0h3 = W(3) : 0h4 = W(4)       '  T  H  EEPROM

If Hour_last > Hour Then
  If Rec = 0 Then


     I2cstart
     I2cwbyte Block
     I2cwbyte Page

     I2cwbyte Dat
     I2cwbyte Month
     I2cwbyte Year
     I2cwbyte Day
     I2cwbyte 0t1
     I2cwbyte 0t2
     I2cwbyte 0t3
     I2cwbyte 0t4
     I2cwbyte 0h1
     I2cwbyte 0h2
     I2cwbyte 0h3
     I2cwbyte 0h4
     I2cwbyte 6t1
     I2cwbyte 6t2
     I2cwbyte 6h1
     I2cwbyte 6h2

     I2cstop

     Page = Page + 16


       If Page = 0 Then

           Incr Block_number


              If Block_number = 8 Then
                 Block_number = 0
              End If


            Select Case Block_number

             Case 0 : Block = &HA0
             Case 1 : Block = &HA2
             Case 2 : Block = &HA4
             Case 3 : Block = &HA6
             Case 4 : Block = &HA8
             Case 5 : Block = &HAA
             Case 6 : Block = &HAC
             Case 7 : Block = &HAE


            End Select

       End If

  '       
    Block_eeprom = Block
    Page_eeprom = Page
    Block_number_eeprom = Block_number


     Rec = 1                                                '  ,   ,     

  End If

Else

 Rec = 0

End If


Return
'-------------------------------------------------------------------------------



'    RS485
Sub Rs_485:

  $timeout = 10000
If Ischarwaiting() = 1 Then
 For Irs = 1 To 5
   Drs(irs) = Inkey()
   Waitms 1
 Next
Clear Serialin
If Drs(1) = Num Or Drs(1) = Zapros Then
Select Case Drs(2)
'-----------------------  1 ---------------------------------

Case 1

Cls                                                         '    
 Lcd " ae RS485"
Print Fusing(t , "#.#") ; "C  " ; Hour ; ":" ; Mine
Print Fusing(h , "#.#") ; "%  " ; Hour ; ":" ; Mine
Print "FEN =" ; Q1 ; "  *1=In 0=Out* " ; "% L= " ; Tem1 ; " H= " ; Tem2
Print "NAG =" ; Q2 ; "  *1=In 0=Out* " ; "C L= " ; Vla2 ; " H= " ; Vla1

   Wait 1

'-----------------------  2 ---------------------------------
Case 2
 24cxx:
'    EEPROM 24c16.
' Print " Chip is absent "                                   '   
Cls
 Lcd "epea  24c16>"
 Locate 2 , 1
 Lcd "> > >RS485> > >"
 '  2416
   I2cstart                                                 '   i2c 
   I2cwbyte &B10100000                                      '      
   I2cwbyte &H00                                            '    

   I2cstart                                                 '  
   I2cwbyte &B10100001                                      '          
Do
   Incr Zoomzoom                                            '     

   '   

   I2crbyte A1 , Ack
   I2crbyte A2 , Ack
   I2crbyte A3 , Ack
   I2crbyte A4 , Ack
   I2crbyte A5 , Ack
   I2crbyte A6 , Ack
   I2crbyte A7 , Ack
   I2crbyte A8 , Ack
   I2crbyte A9 , Ack
   I2crbyte A10 , Ack
   I2crbyte A11 , Ack
   I2crbyte A12 , Ack
   I2crbyte A13 , Ack
   I2crbyte A14 , Ack
   I2crbyte A15 , Ack

    If Zoomzoom < 128 Then

   I2crbyte A16 , Ack

    Else

   I2crbyte A16 , Nack

    End If

    '**********************************
    '    4      Single.
    '******************************

W(1) = A5 : W(2) = A6 : W(3) = A7 : W(4) = A8 : Call _ : T00 = S2 : Ttt = Fusing(t00 , "#.#")

W(1) = A9 : W(2) = A10 : W(3) = A11 : W(4) = A12 : Call _ : H00 = S2 : 00h = Fusing(h00 , "#.#")

W(1) = A13 : W(2) = A14 : W(3) = A7 : W(4) = A8 : Call _ : T06 = S2 : 06t = Fusing(t06 , "#.#")       '?

W(1) = A15 : W(2) = A16 : W(3) = A11 : W(4) = A12 : Call _ : H06 = S2 : 06h = Fusing(h06 , "#.#")       '?

'  
Print " " ; A1 ; "/" ; A2 ; "/" ; A3 ; "." ; A4 ; " = " ; Ttt ; "C " ; 00h ; "% " ; " 6:00= " ; 06t ; "C " ; 06h ; "% "
   Loop Until Zoomzoom = 128                                
       I2cstop
 Zoomzoom = 0
 Wait 1

End Select
End If
End If
End Sub

'------------------------------------------------------------------------------

Sub 

'  
Adress = Varptr(s1)
 For I = 1 To 4
  W(i) = Inp(adress)
  Incr Adress
 Next

 End Sub
'------------------------------------------------------------------------------

Sub _

' 
 Adress = Varptr(s2)
 For I = 1 To 4
   Out Adress , W(i)
   Incr Adress
 Next

End Sub
